SystemOrganization addCategory: #'SeasideOverflow-Model'!
SystemOrganization addCategory: #'SeasideOverflow-Test'!
SystemOrganization addCategory: #'SeasideOverflow-View'!

WAComponent subclass: #AddAnswerView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-View'!

!AddAnswerView methodsFor: 'accessing' stamp: 'FredHsu 7/5/2012 11:20'!
model
	^ model! !

!AddAnswerView methodsFor: 'accessing' stamp: 'FredHsu 7/5/2012 11:20'!
model: anObject
	model := anObject! !

!AddAnswerView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/5/2012 11:18'!
renderContentOn: html
	html heading: 'Add Answer'.
	   html form: [
        html text: 'Answer'; break.
        html textInput
            callback: [ :value | self model text: value ].
  html submitButton
            callback: [ self answer: self model ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]! !

WAComponent subclass: #AddQuestionView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-View'!

!AddQuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:05'!
model
	^ model! !

!AddQuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:05'!
model: anObject
	model := anObject! !

!AddQuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:08'!
renderContentOn: html
	html heading: 'Add Question'.
	   html form: [
        html text: 'Title:'; break.
        html textInput
            value: self model title;
            callback: [ :value | self model title: value ].
  html submitButton
            callback: [ self answer: self model ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]
! !

WAComponent subclass: #QuestionListView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-View'!

!QuestionListView class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:14'!
initialize 
	"QuestionListView initialize"
	WAAdmin register: self asApplicationAt: 'so'.! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:34'!
addQuestion
	| newQuestion |
	newQuestion := self call: (AddQuestionView new model: (Question by: 'testuser' with: 'testquestion')).
	self model add: newQuestion
	! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:33'!
initialize 
	super initialize.
	model := QuestionList new.
	model add: ((Question by: 'me' with: 'text') title: 'new title')! !

!QuestionListView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:33'!
model
	^ model! !

!QuestionListView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:33'!
model: anObject
	model := anObject! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:03'!
renderContentOn: html
	html heading: 'Seaside Overflow'.
	html anchor
		callback: [ self addQuestion ];
		with: 'Add Question'.
	html unorderedList: [ self renderQuestionsOn: html ]
	! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:23'!
renderQuestion: aQuestion on: html
	html listItem with: [
		html text: aQuestion votes.
		html space.
		html text: aQuestion answers size.
		html space.
		html text: aQuestion views.
		html space.
		html anchor
			callback: [self viewQuestion: aQuestion];
			with: aQuestion title.
		html space.
		aQuestion tags do: [:each |
			html text: each.
			html space].
		html text: aQuestion date.
		html space.
		html text: aQuestion user. ]! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:33'!
renderQuestionsOn: html
	model questions do: [:each | self renderQuestion: each on: html]! !

!QuestionListView methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:24'!
viewQuestion: aQuestion
	self call: (QuestionView new model: aQuestion)
	! !

WAComponent subclass: #QuestionView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-View'!

!QuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/5/2012 11:20'!
addAnswer
	| newAnswer |
	newAnswer := self call: (AddAnswerView new model: (Answer by: 'testuser' with: 'testanswer')).
	self model addAnswer: newAnswer! !

!QuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:20'!
model
	^ model! !

!QuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:20'!
model: anObject
	model := anObject! !

!QuestionView methodsFor: 'accessing' stamp: 'FredHsu 7/5/2012 11:25'!
renderContentOn: html
	html heading: model title.
	html horizontalRule.
	html text: model text.
	html break.
	html heading: 'Answers'.
	model answers do: [ :each |
		html text: each text.
		html horizontalRule].
	html anchor
		callback: [ self addAnswer ];
		with: 'Add Answer'.! !

TestCase subclass: #AnswerTest
	instanceVariableNames: 'anAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!AnswerTest class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
testBy
	| anAnswer |
	anAnswer := Answer by: 'Fred Hsu'.
	self assert: (anAnswer user) = 'Fred Hsu'.
	self assert: (anAnswer votes) = 0.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:23'!
setUp
	| user answerText |
	super setUp.
	user := 'Fred Hsu'.
	answerText := '42'.
	anAnswer := Answer by: user with: answerText.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:22'!
testByWith
	| ans user answerText|
	user := 'Fred Hsu'.
	answerText := 'This is my answer.'.
	ans := Answer by: user with: answerText.
	self assert: (ans user) = user.
	self assert: (ans votes) = 0.
	self assert: (ans text) = answerText.! !

!AnswerTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:17'!
testUpDownVote
	anAnswer upVote.
	self assert: anAnswer votes = 1.
	anAnswer upVote.
	self assert: anAnswer votes = 2.
	anAnswer downVote.
	self assert: anAnswer votes = 1.
	anAnswer downVote.
	self assert: anAnswer votes = 0.
	anAnswer downVote.
	self assert: anAnswer votes = -1.
! !

TestCase subclass: #QuestionListTest
	instanceVariableNames: 'questions questionList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!QuestionListTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:06'!
setUp
	questionList := QuestionList new.
	questionList add: (Question by: 'Fred Hsu' with: 'What do you want?')! !

!QuestionListTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:07'!
testAdd
	questionList add: (Question by: 'User1' with: 'How can I?')! !

!QuestionListTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:33'!
testRemove
! !

TestCase subclass: #QuestionTest
	instanceVariableNames: 'question'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Test'!

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:08'!
setUp
	| user questionText  |
	super setUp.
	user := 'Fred Hsu'.
	questionText := 'What is the meaning to life, the universe, and everything?'.
	question := Question by: user with: questionText.! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:36'!
testAddAnswer
	| answer1 answer2 answer3 |
	answer1 := Answer by: 'user1' with: 'answerText1'.
	answer2 := Answer by: 'user2' with: 'answerText2'.
	answer3 := Answer by: 'user3' with: 'answerText3'.
	question addAnswer: answer1.
	self assert: (question answers includes: answer1).
	question addAnswer: answer2.
	self assert: (question answers includes: answer2).
	question addAnswer: answer3.	
	self assert: (question answers includes: answer3).
! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:31'!
testAddRemoveTags
	question addTag: 'foo'.
	self assert: (question hasTag: 'foo').
	question removeTag: 'foo'.
	self assert: ((question hasTag: 'foo') not).! !

!QuestionTest methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:13'!
testIncrementViews
	self assert: question views = 0.
	question incrementViews.
	self assert: question views = 1.
	question incrementViews.
	self assert: question views = 2.! !

Object subclass: #Entry
	instanceVariableNames: 'text user votes date'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Entry commentStamp: 'FredHsu 7/3/2012 23:15' prior: 0!
Entry a superclass for questions and answers

Instance Variables:
	text	<ProtoObject | PseudoContext>
	user	<ProtoObject | PseudoContext>
	votes	<Number>
	date	<Date>!

Entry subclass: #Answer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Answer commentStamp: 'FredHsu 7/3/2012 21:41' prior: 0!
An answer to a question!

!Entry class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:20'!
by: aUser with: someText
	^self new by: aUser with: someText.! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:19'!
by: aUser with: someText
	user := aUser.
	date := Date today.
	text := someText.
	votes := 0.
	! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:10'!
date
	^date! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:11'!
downVote
	votes := votes - 1! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:23'!
text
	^text! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/5/2012 11:21'!
text: aString
	text := aString! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:10'!
upVote
	votes := votes + 1! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
user
	^user! !

!Entry methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 22:09'!
votes
	^votes! !

Entry subclass: #Question
	instanceVariableNames: 'answers views tags title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!Question commentStamp: 'FredHsu 7/3/2012 21:41' prior: 0!
A question posed by a user!

!Question class methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:13'!
by: aUser
	^self new by: aUser! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:32'!
addAnswer: anAnswer
	answers add: anAnswer.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:25'!
addTag: aTag
	tags add: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
answers
	^answers! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:14'!
by: aUser
	self by: aUser with: ''! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 23:15'!
by: aUser with: someText
	super by: aUser with: someText.
	answers := OrderedCollection new.
	views := 0.
	tags := Set new.
	title := 'new title'! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:28'!
hasTag: aTag
	^tags includes: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:24'!
incrementViews 
	views := views + 1.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:29'!
removeTag: aTag
	tags remove: aTag.! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
tags
	^tags! !

!Question methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:07'!
title
	^ title! !

!Question methodsFor: 'accessing' stamp: 'FredHsu 7/4/2012 23:07'!
title: anObject
	title := anObject! !

!Question methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/3/2012 23:23'!
views
	^views! !

Object subclass: #QuestionList
	instanceVariableNames: 'questions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!QuestionList commentStamp: 'FredHsu 7/3/2012 23:15' prior: 0!
QuestionListing is a list of questions on the system

	questions	<ProtoObject | PseudoContext>!

!QuestionList methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:03'!
add: aQuestion
	questions add: aQuestion! !

!QuestionList methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:05'!
initialize
	super initialize.
	questions := SortedCollection sortBlock: [:q1 :q2 | q1 date <= q2 date].! !

!QuestionList methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:08'!
questions
	^questions! !

!QuestionList methodsFor: 'as yet unclassified' stamp: 'FredHsu 7/4/2012 22:04'!
remove: aQuestion
	questions remove: aQuestion! !

Object subclass: #User
	instanceVariableNames: 'userName password profileType isActive memberSince dateUpdated isLoggedIn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:40'!
addUser: aUserName passcode: aPassword
	userName := aUserName.
	password := aPassword.
	dateUpdated := Date new.
	memberSince := Date new.
	isActive := 'Y'.
	isLoggedIn := 'N'.
	profileType := 'USER'.! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:20'!
dateUpdated
	^dateUpdated! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:24'!
initialize
	userName := ''.
	password := ''.
	profileType := 'USER'.
	isActive := 'N'.
	memberSince := Date new.
	dateUpdated := Date new.! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:19'!
isActive
	^isActive! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:27'!
isLoggedIn
	^isLoggedIn! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:47'!
makeAdmin
	self profileType: 'ADMIN'.
	dateUpdated := Date new.! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:57'!
makeInactive
	isActive := 'N'.
	dateUpdated := Date new.! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:20'!
memberSince
	^memberSince! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:18'!
password
	^password! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:19'!
profileType
	^profileType! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:44'!
profileType: aType
	profileType := aType.! !

!User methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:18'!
userName
	^userName! !

Object subclass: #UserList
	instanceVariableNames: 'users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideOverflow-Model'!

!UserList methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:54'!
add: aUser
	users add: aUser.! !

!UserList methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:54'!
initialize
	super initialize.
	users := OrderedCollection new.! !

!UserList methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:55'!
remove: aUser
	users remove: aUser! !

!UserList methodsFor: 'as yet unclassified' stamp: 'ParamvirSingh 7/5/2012 23:55'!
users
	^users! !
QuestionListView initialize!
